#include <amxmodx>
#include <zombieplague>
#include <hamsandwich>
#include <nvault>

#define VAULT_NAME "zp_zombie_class"

new g_Vault, zombie_id[MAX_PLAYERS+1];

public plugin_init()
{
	g_Vault = nvault_open(VAULT_NAME);
	RegisterHamPlayer(Ham_Spawn, "player_respawn", 0);
	if (g_Vault == INVALID_HANDLE)
		set_fail_state("Error opening '%s' nVault.", VAULT_NAME);
}

public plugin_end()
{
	nvault_close(g_Vault);
}

public player_respawn(client)
{
	if(zp_get_user_zombie_class(client) != zombie_id[client]) {
		zp_set_user_zombie_class(client, zombie_id[client]);

		new szAuthId[64];
		get_user_authid(client,szAuthId,charsmax(szAuthId));

		new szClass[10];
		num_to_str(zp_get_user_next_class(client) == -1 ? zombie_id[client] : zp_get_user_next_class(client),szClass,charsmax(szClass));

		nvault_set(g_Vault,szAuthId,szClass);
	}
}

public client_putinserver(client)
{
	if(!is_user_bot(client) && !is_user_hltv(client))
	{
		new szAuthId[64];
		get_user_authid(client,szAuthId,charsmax(szAuthId));

		zombie_id[client] = nvault_get(g_Vault,szAuthId);

		/* new szKey[40], buffer[4];
		get_user_authid(client, szKey, sizeof(szKey));

		format(szKey, charsmax(szKey), "%sZOMBIEID", szKey);
		nvault_get(g_Vault, szKey, buffer, sizeof(buffer));
		zombie_id[client] = str_to_num(buffer); */
	}
}

/* public client_disconnected(client)
{
	if(!is_user_bot(client) && !is_user_hltv(client))
	{
		new szZombie[7], szKey[40]
		get_user_authid(client, szKey, sizeof(szKey));

		format(szKey, charsmax(szKey), "%sZOMBIEID", szKey);
		formatex(szZombie, charsmax(szZombie), "%d", zp_get_user_next_class(client) == -1 ? zombie_id[client] : zp_get_user_next_class(client));

		nvault_set(g_Vault, szKey, szZombie);
	}
} */

public zp_user_infected_post(client, infector, nemesis)
{
	zombie_id[client] = zp_get_user_zombie_class(client);
}